<template>
  <Head title="Order" />

  <Layout>
    <div class="max-w-full mx-auto sm:px-2 lg:px-2">
      <div class="lg:flex lg:items-center lg:justify-between py-4">
        <div class="flex-1 min-w-0">
          <!-- {/* Title Page */} -->
          <h2
            class="
              text-2xl
              font-semibold
              text-gray-700
              dark:text-gray-200
              sm:text-3xl sm:truncate
            "
          >
            Order
          </h2>
          <!-- {/* Breadcumb */} -->
          <div
            class="
              mt-1
              flex flex-col
              sm:flex-row sm:flex-wrap sm:mt-0 sm:space-x-6
            "
          >
            <ul class="flex text-gray-900 text-sm lg:text-base">
              <li class="inline-flex items-center">
                <Link :href="route('dashboard')">Dashboard</Link>
                <Icon
                  :name="`chevron-right`"
                  :style="`h-5 w-auto text-gray-400`"
                />
              </li>
              <li class="inline-flex items-center">
                <Link :href="route('order')"> Order </Link>
                <Icon
                  :name="`chevron-right`"
                  :style="`h-5 w-auto text-gray-400`"
                />
              </li>
              <li class="inline-flex items-center">
                <Link :href="route('order.create')" class="text-gray-500">
                  Create
                </Link>
              </li>
            </ul>
          </div>
        </div>
        <div class="mt-5 flex lg:mt-0 lg:ml-4"></div>
      </div>

      <div class="flex flex-wrap overflow-hidden rounded-lg shadow-xs">
        <!-- <div class="flex shadow-md my-10"> -->

        <div class="lg:w-3/5 sm:w-full bg-white px-10 py-10">
          <div class="flex justify-between border-b pb-8">
            <h2 class="font-semibold text-2xl">Menu List</h2>
            <!-- <h2 class="font-semibold text-2xl">{{ menus.data.length }} Items</h2> -->
          </div>

          <div class="flex flex-wrap">
            <div
              v-for="menu in menus.data"
              :key="menu.id"
              class="w-full sm:w-full md:w-full xl:w-1/3 p-2"
            >
              <a
                @click="addtoCart(menu)"
                class="
                  c-card
                  block
                  bg-white
                  shadow-md
                  hover:shadow-xl
                  rounded-lg
                  overflow-hidden
                "
                style="cursor: pointer"
              >
                <div class="relative pb-48 overflow-hidden">
                  <img
                    class="absolute inset-0 h-full w-full object-cover"
                    :src="
                      menu.cover
                        ? '/storage/images/' + menu.cover
                        : '/images/image-not-found.png'
                    "
                    :alt="menu.name"
                  />
                </div>
                <div class="p-4">
                  <span
                    class="
                      inline-block
                      px-2
                      py-1
                      leading-none
                      bg-orange-200
                      text-orange-800
                      rounded-full
                      uppercase
                      tracking-wide
                      font-thin
                      text-xs
                    "
                  >
                    {{ menu.categoryName }}
                  </span>
                  <h2 class="mt-2 mb-2 font-thin text-xs">
                    {{ menu.name }}
                  </h2>
                  <div class="mt-3 flex items-center">
                    <span class="text-sm font-semibold">Rp</span>&nbsp;<span
                      class="font-bold text-md"
                      >{{ formatPrice(menu.price) }}</span
                    >
                  </div>
                </div>
              </a>
            </div>
          </div>
          <!-- Pagination -->
          <Pagination
            :links="menus.links"
            :from="menus.from"
            :to="menus.to"
            :total="menus.total"
          />
        </div>

        <div id="summary" class="lg:w-2/5 sm:w-full px-8 py-10">
          <h2 class="font-semibold text-2xl border-b pb-8">Order Summary</h2>
          <div v-if="form.cartItems.length > 0">
            <div class="flex justify-between mt-10 mb-5">
              <span class="font-semibold text-sm uppercase"
                >Items {{ form.cartItems.length }}</span
              >
              <span class="font-semibold text-sm">{{
                formatPrice(form.subTotal)
              }}</span>
            </div>

            <table class="w-full text-sm" cellspacing="0">
              <thead>
                <tr class="h-12">
                  <th class="hidden md:table-cell text-left" colspan="2">
                    Product
                  </th>
                  <!-- <th class="text-left">Product</th> -->
                  <th class="lg:text-center text-left pl-5 lg:pl-0">
                    <span class="lg:hidden" title="Quantity">Qty</span>
                    <span class="hidden lg:inline">Qty</span>
                  </th>
                  <th class="hidden text-center md:table-cell">Unit price</th>
                  <th class="text-center">Total price</th>
                </tr>
              </thead>
              <tbody>
                <tr
                  class="font-thin text-xs"
                  v-for="(item, i) in form.cartItems"
                  :key="i"
                >
                  <td class="hidden pb-4 md:table-cell">
                    <img
                      class="w-20 rounded"
                      :src="
                        item.cover
                          ? '/storage/images/' + item.cover
                          : '/images/image-not-found.png'
                      "
                      :alt="item.name"
                    />
                  </td>
                  <td>
                    <p class="mb-2 md:ml-4">{{ item.name }}</p>
                    <a
                      style="cursor: pointer"
                      @click="deleteCart(i)"
                      class="font-thin hover:text-red-500 text-gray-500 text-xs"
                    >
                      <small>(Remove item)</small>
                    </a>
                  </td>
                  <td class="justify-center md:justify-end md:flex mt-6">
                    <div class="w-20 h-10">
                      <div class="relative flex flex-row w-full h-8">
                        <svg
                          @click="updateCart('remove', item.id, i)"
                          style="cursor: pointer"
                          class="fill-current text-gray-600 w-3"
                          viewBox="0 0 448 512"
                        >
                          <path
                            d="M416 208H32c-17.67 0-32 14.33-32 32v32c0 17.67 14.33 32 32 32h384c17.67 0 32-14.33 32-32v-32c0-17.67-14.33-32-32-32z"
                          />
                        </svg>
                        <input
                          type="text"
                          readonly
                          :value="item.qty"
                          @click="updateCart(item.id, i)"
                          class="
                            w-12
                            font-thin
                            text-center text-gray-700
                            bg-gray-200
                            outline-none
                            focus:outline-none
                            hover:text-black
                            focus:text-black
                            mx-2
                            border
                            text-center
                          "
                        />
                        <svg
                          @click="updateCart('add', item.id, i)"
                          style="cursor: pointer"
                          class="fill-current text-gray-600 w-3"
                          viewBox="0 0 448 512"
                        >
                          <path
                            d="M416 208H272V64c0-17.67-14.33-32-32-32h-32c-17.67 0-32 14.33-32 32v144H32c-17.67 0-32 14.33-32 32v32c0 17.67 14.33 32 32 32h144v144c0 17.67 14.33 32 32 32h32c17.67 0 32-14.33 32-32V304h144c17.67 0 32-14.33 32-32v-32c0-17.67-14.33-32-32-32z"
                          />
                        </svg>
                      </div>
                    </div>
                  </td>
                  <td class="text-right mfont-thin text-xs">
                    {{ formatPrice(item.price) }}
                  </td>
                  <td class="text-right font-thin text-xs">
                    {{ formatPrice(item.total) }}
                  </td>
                </tr>
              </tbody>
            </table>

            <form @submit.prevent="store">
              <div class="border-t mt-4">
                <div class="py-2">
                  <label class="font-medium inline-block mb-3 text-sm uppercase"
                    >Table List</label
                  >
                  <select
                    class="block p-2 text-gray-600 w-full text-sm"
                    v-model="form.table_order"
                    tabindex="1"
                  >
                    <option
                      v-for="table in tables"
                      :key="table.id"
                      :value="table.id"
                    >
                      {{ table.name }}
                    </option>
                  </select>
                </div>
                <div class="py-2">
                  <label class="font-medium inline-block mb-3 text-sm uppercase"
                    >Payment Method</label
                  >
                  <select
                    class="block p-2 text-gray-600 w-full text-sm"
                    v-model="form.type_payment"
                    tabindex="2"
                  >
                    <option>Cash</option>
                    <option>Transfer</option>
                  </select>
                </div>
                <div class="py-2">
                  <label
                    for="customer_name"
                    class="font-semibold inline-block mb-3 text-sm uppercase"
                    >Customer Name</label
                  >
                  <input
                    type="text"
                    id="customer_name"
                    v-model="form.customer_name"
                    placeholder="Customer Name .."
                    :class="
                      form.errors.customer_name
                        ? 'p-2 text-sm w-full focus:ring-red-500 focus:border-red-500 border-red-600'
                        : 'p-2 text-sm w-full'
                    "
                    tabindex="3"
                  />
                  <div
                    v-if="form.errors.customer_name"
                    className="py-1 text-red-600 text-sm font-medium"
                  >
                    {{ form.errors.customer_name }}
                  </div>
                  <!-- focus:ring-red-500 focus:border-red-500 border-red-600 -->
                </div>
                <div class="py-2">
                  <label
                    for="customer_phone"
                    class="font-semibold inline-block mb-3 text-sm uppercase"
                    >Customer Phone</label
                  >
                  <input
                    type="text"
                    id="customer_phone"
                    v-model="form.customer_phone"
                    placeholder="Customer Phone .."
                    class="p-2 text-sm w-full"
                    tabindex="4"
                  />
                </div>
                <div class="py-2">
                  <label
                    for="notes"
                    class="font-semibold inline-block mb-3 text-sm uppercase"
                    >Notes</label
                  >
                  <input
                    type="text"
                    id="notes"
                    v-model="form.notes"
                    placeholder="Notes .."
                    class="p-2 text-sm w-full"
                    tabindex="5"
                  />
                </div>
                <div
                  class="
                    flex
                    font-semibold
                    justify-between
                    py-2
                    text-sm
                    uppercase
                  "
                >
                  <span>Subtotal</span>
                  <span>{{ formatPrice(form.subTotal) }}</span>
                </div>
                <div
                  class="
                    flex
                    font-semibold
                    justify-between
                    py-2
                    text-sm
                    uppercase
                  "
                >
                  <span>PPN (%)</span>
                  <span>{{ form.ppn }}</span>
                </div>
                <div
                  class="
                    flex
                    font-semibold
                    justify-between
                    py-2
                    text-sm
                    uppercase
                  "
                >
                  <span>Total cost</span>
                  <span>{{ formatPrice(form.charge_value) }}</span>
                </div>
                <div class="py-2">
                  <label
                    for="payment"
                    class="font-semibold inline-block mb-3 text-sm uppercase"
                    >Payment</label
                  >
                  <!-- :value="form.payment"
                    @input="changeCharge(0, $event.target.value)" -->
                  <input
                    type="text"
                    id="payment"
                    v-model="form.payment_value"
                    @input="changeCharge($event.target.value)"
                    @keypress="NumbersOnly($event)"
                    pattern="[0-9]*"
                    placeholder="Payment Value .."
                    class="p-2 text-sm w-full"
                    tabindex="6"
                  />
                </div>
                <Button
                  type="button"
                  style="margin-right: 2px"
                  class="text-xs font-thin hover:text-white py-2 px-2 rounded"
                  @click="addPayment(50000)"
                >
                  <Icon :name="`money`" :style="`-ml-1 mr-2 h-5 w-5`" />
                  50000
                </Button>
                <Button
                  type="button"
                  style="margin-right: 2px"
                  class="text-xs font-thin hover:text-white py-2 px-2 rounded"
                  @click="addPayment(100000)"
                >
                  <Icon :name="`money`" :style="`-ml-1 mr-2 h-5 w-5`" />
                  100000
                </Button>
                <Button
                  type="button"
                  style="margin-right: 2px"
                  class="text-xs font-thin hover:text-white py-2 px-2 rounded"
                  @click="addPayment(150000)"
                >
                  <Icon :name="`money`" :style="`-ml-1 mr-2 h-5 w-5`" />
                  150000
                </Button>
                <Button
                  type="button"
                  class="text-xs font-thin hover:text-white py-2 px-2 rounded"
                  @click="addPayment(200000)"
                >
                  <Icon :name="`money`" :style="`-ml-1 mr-2 h-5 w-5`" />
                  200000
                </Button>
                <div
                  class="
                    flex
                    font-semibold
                    justify-between
                    py-2
                    text-sm
                    uppercase
                  "
                >
                  <span>Change</span>
                  <span>{{ formatPrice(form.change_value) }}</span>
                </div>
                <button
                  v-if="form.payment_value >= form.charge_value"
                  type="submit"
                  class="
                    bg-indigo-500
                    font-semibold
                    hover:bg-indigo-600
                    py-3
                    text-sm text-white
                    uppercase
                    w-full
                  "
                  tabindex="7"
                >
                  Charge
                </button>
              </div>
            </form>
          </div>
          <div v-else class="my-5">
            <span class="font-semibold text-sm uppercase">No Order Found</span>
          </div>
        </div>

        <!-- </div> -->
      </div>
    </div>
  </Layout>
</template>

<script>
import Layout from "@/Layouts/App.vue";
import { Head } from "@inertiajs/inertia-vue3";
import { Link } from "@inertiajs/inertia-vue3";
import Icon from "@/Components/Icon";
import Input from "@/Components/Input.vue";
import Label from "@/Components/Label.vue";
import Button from "@/Components/Button.vue";
import Multiselect from "@suadelabs/vue3-multiselect";
import Pagination from "@/Components/Pagination.vue";

export default {
  components: {
    Layout,
    Head,
    Link,
    Icon,
    Button,
    Input,
    Label,
    Multiselect,
    Pagination,
  },
  props: {
    categories: Object,
    tables: Object,
    menus: Object,
  },
  data() {
    return {
      form: this.$inertia.form({
        table_order: null,
        customer_name: null,
        customer_phone: null,
        type_payment: null,
        notes: null,
        cartItems: [],
        subTotal: 0,
        ppn: 10,
        charge_value: 0,
        payment_value: 0,
        change_value: 0,
      }),
    };
  },
  beforeMount() {
    this.getCart();
    this.getSubtotal();
    this.getAllTotal();
  },
  methods: {
    store() {
      // this.form.post(this.route("order.store"));
      this.form.post(this.route("order.store"), {
        // preserveScroll: true,
        onSuccess: () => localStorage.setItem("cart", JSON.stringify([])),
      });
    },
    removeCart() {
      localStorage.setItem("cart", JSON.stringify([]));
    },
    getCart() {
      if (!localStorage.getItem("cart")) {
        localStorage.setItem("cart", JSON.stringify([]));
      }
      this.form.cartItems = JSON.parse(localStorage.getItem("cart"));
    },
    addtoCart(item) {
      let itemId = item.id;
      let menu = {
        id: item.id,
        name: item.name,
        price: item.price,
        qty: 1,
        cover: item.cover,
        total: item.price * 1,
      };

      let item_in_cart = this.form.cartItems.filter(function (menu) {
        return menu.id == itemId;
      })[0];

      if (!localStorage.getItem("cart")) {
        localStorage.setItem("cart", JSON.stringify([]));
      }

      const cartTempItems = JSON.parse(localStorage.getItem("cart"));

      if (item_in_cart === undefined) {
        cartTempItems.push(menu);
        localStorage.setItem("cart", JSON.stringify(cartTempItems));
        this.form.cartItems = JSON.parse(localStorage.getItem("cart"));
      } else {
        item_in_cart.qty++;
        item_in_cart.total = item_in_cart.price * item_in_cart.qty;
        localStorage.setItem("cart", JSON.stringify([]));
        localStorage.setItem("cart", JSON.stringify(this.form.cartItems));
      }
      this.getSubtotal();
      this.getAllTotal();
    },
    updateCart(type, menuId, index) {
      let item_in_cart = this.form.cartItems.filter(function (menu) {
        return menu.id == menuId;
      })[0];

      if (type === "add") {
        item_in_cart.qty++;
      } else if (type === "remove") {
        item_in_cart.qty--;
        if (item_in_cart.qty == 0) {
          this.deleteCart(index);
        }
      }

      item_in_cart.total = item_in_cart.price * item_in_cart.qty;

      localStorage.setItem("cart", JSON.stringify([]));
      localStorage.setItem("cart", JSON.stringify(this.form.cartItems));

      this.getSubtotal();
      this.getAllTotal();
    },
    deleteCart(i) {
      this.form.cartItems.splice(i, 1);
      localStorage.setItem("cart", JSON.stringify([]));
      localStorage.setItem("cart", JSON.stringify(this.form.cartItems));

      this.getSubtotal();
      this.getAllTotal();
    },
    getSubtotal() {
      let subTotal = 0;
      this.form.cartItems.forEach((cart) => {
        subTotal += cart.total;
      });

      this.form.subTotal = subTotal;
    },
    getAllTotal() {
      let percent = (this.form.ppn / 100) * this.form.subTotal;
      this.form.charge_value = parseInt(this.form.subTotal) + parseInt(percent);
      this.form.payment_value = this.form.charge_value;
      this.form.change_value = this.form.charge_value - this.form.payment_value;
    },
    changeCharge(value) {
      const v = parseInt(value, 10); // value from input is always string
      let totalCharge = v - parseInt(this.form.charge_value);
      if (!isNaN(totalCharge)) {
        this.form.change_value = totalCharge.toFixed(0);
      } else {
        this.form.change_value = 0;
      }
    },
    addPayment(value) {
      this.form.payment_value = value;
      this.changeCharge(value);
    },
    NumbersOnly(evt) {
      evt = evt ? evt : window.event;
      var charCode = evt.which ? evt.which : evt.keyCode;
      if (
        charCode > 31 &&
        (charCode < 48 || charCode > 57) &&
        charCode !== 46
      ) {
        evt.preventDefault();
      } else {
        return true;
      }
    },
    formatPrice(value) {
      let val = (value / 1).toFixed(2).replace(".", ",");
      return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
    },
  },
};
</script>
